/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-4-OptTabl.aml, Thu Dec 21 00:44:57 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000014E9 (5353)
 *     Revision         0x01
 *     Checksum         0x88
 *     OEM ID           "OptRef"
 *     OEM Table ID     "OptTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20091112 (537465106)
 */
DefinitionBlock ("", "SSDT", 1, "OptRef", "OptTabl", 0x00001000)
{
    External (_PR_.CPU0, ProcessorObj)
    External (_PR_.CPU0._PPC, IntObj)
    External (_PR_.CPU0._PSS, PkgObj)
    External (_PR_.CPU1, ProcessorObj)
    External (_PR_.CPU2, ProcessorObj)
    External (_PR_.CPU3, ProcessorObj)
    External (_PR_.CPU4, ProcessorObj)
    External (_PR_.CPU5, ProcessorObj)
    External (_PR_.CPU6, ProcessorObj)
    External (_PR_.CPU7, ProcessorObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.GFX0, DeviceObj)
    External (_SB_.PCI0.GFX0._DSM, MethodObj)    // 4 Arguments
    External (_SB_.PCI0.GFX0.CLID, FieldUnitObj)
    External (_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (_SB_.PCI0.PEG0.PEGP.NVSM, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGOF, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGON, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGST, MethodObj)    // 0 Arguments
    External (DID1, FieldUnitObj)
    External (DID2, FieldUnitObj)
    External (DID3, FieldUnitObj)
    External (DID4, FieldUnitObj)
    External (DID5, FieldUnitObj)
    External (DID6, FieldUnitObj)
    External (DID7, FieldUnitObj)
    External (DID8, FieldUnitObj)
    External (EBAS, FieldUnitObj)
    External (FPPC, FieldUnitObj)
    External (NVGA, FieldUnitObj)
    External (NVHA, FieldUnitObj)
    External (NXD1, FieldUnitObj)
    External (NXD2, FieldUnitObj)
    External (NXD3, FieldUnitObj)
    External (NXD4, FieldUnitObj)
    External (NXD5, FieldUnitObj)
    External (NXD6, FieldUnitObj)
    External (NXD7, FieldUnitObj)
    External (NXD8, FieldUnitObj)
    External (P8XH, MethodObj)    // 2 Arguments
    External (PDC1, IntObj)
    External (PDC2, IntObj)
    External (PDC3, IntObj)
    External (PDC4, IntObj)
    External (PDC5, IntObj)
    External (PDC6, IntObj)
    External (PDC7, IntObj)

    Scope (\_SB.PCI0)
    {
        Name (OTM, "OTMACPI 2010-Mar-09 12:08:26")
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (NVHM, SystemMemory, NVHA, 0x00010400)
        Field (NVHM, AnyAcc, NoLock, Preserve)
        {
            NVSG,   128, 
            NVSZ,   32, 
            NVVR,   32, 
            NVHO,   32, 
            RVBS,   32, 
            RBF1,   262144, 
            RBF2,   262144, 
            MXML,   32, 
            MXM3,   1600
        }

        Method (_ROM, 2, NotSerialized)  // _ROM: Read-Only Memory
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                     0x00                                           
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                 0x00                                           
            })
            Name (ROM2, Buffer (Local1)
            {
                 0x00                                           
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }

        Name (OPCE, 0x02)
        Name (OPTF, One)
        Name (DGPS, Zero)
        Name (_PSC, Zero)  // _PSC: Power State Current
        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
            Store (Zero, _PSC)
            If (LNotEqual (DGPS, Zero))
            {
                _ON ()
                Store (Zero, DGPS)
            }

            Store (SID, SIDN)
        }

        Method (_PS1, 0, NotSerialized)  // _PS1: Power State 1
        {
            Store (One, _PSC)
        }

        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
            If (LEqual (OPCE, 0x03))
            {
                If (LEqual (DGPS, Zero))
                {
                    _OFF ()
                    Store (One, DGPS)
                }

                Store (0x02, OPCE)
            }

            Store (0x03, _PSC)
        }

        Method (_STA, 0, NotSerialized)  // _STA: Status
        {
            Return (0x0F)
        }

        Name (OPVK, Buffer (0xE6)
        {
            /* 0000 */  0x53, 0xF1, 0xAC, 0x5E, 0x24, 0xA0, 0x81, 0xAB,
            /* 0008 */  0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00,
            /* 0010 */  0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35,
            /* 0018 */  0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75,
            /* 0020 */  0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44,
            /* 0028 */  0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69,
            /* 0030 */  0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74,
            /* 0038 */  0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61,
            /* 0040 */  0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65,
            /* 0048 */  0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66,
            /* 0050 */  0x6F, 0x72, 0x20, 0x37, 0x34, 0x36, 0x37, 0x39,
            /* 0058 */  0x31, 0x5F, 0x31, 0x31, 0x2E, 0x35, 0x63, 0x20,
            /* 0060 */  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
            /* 0068 */  0x2D, 0x20, 0x34, 0x26, 0x43, 0x4B, 0x29, 0x22,
            /* 0070 */  0x5C, 0x56, 0x48, 0x42, 0x3A, 0x32, 0x2C, 0x33,
            /* 0078 */  0x2D, 0x41, 0x54, 0x3F, 0x25, 0x2E, 0x4C, 0x21,
            /* 0080 */  0x3E, 0x48, 0x2D, 0x5D, 0x5B, 0x58, 0x4A, 0x2A,
            /* 0088 */  0x4D, 0x38, 0x3C, 0x38, 0x3A, 0x2B, 0x2C, 0x41,
            /* 0090 */  0x2B, 0x27, 0x4B, 0x50, 0x3B, 0x4E, 0x2F, 0x5D,
            /* 0098 */  0x28, 0x2C, 0x59, 0x4C, 0x2C, 0x43, 0x20, 0x2D,
            /* 00A0 */  0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67,
            /* 00A8 */  0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20,
            /* 00B0 */  0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43,
            /* 00B8 */  0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69,
            /* 00C0 */  0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52,
            /* 00C8 */  0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65,
            /* 00D0 */  0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31,
            /* 00D8 */  0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36,
            /* 00E0 */  0x39, 0x38, 0x35, 0x28, 0x52, 0x29             
        })
        Name (OPV1, Buffer (0xE6)
        {
            /* 0000 */  0x4F, 0xCA, 0x55, 0x6D, 0x74, 0x1C, 0x57, 0x25,
            /* 0008 */  0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00,
            /* 0010 */  0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35,
            /* 0018 */  0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75,
            /* 0020 */  0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44,
            /* 0028 */  0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69,
            /* 0030 */  0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74,
            /* 0038 */  0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61,
            /* 0040 */  0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65,
            /* 0048 */  0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66,
            /* 0050 */  0x6F, 0x72, 0x20, 0x37, 0x37, 0x34, 0x32, 0x39,
            /* 0058 */  0x30, 0x5F, 0x31, 0x31, 0x36, 0x63, 0x20, 0x20,
            /* 0060 */  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
            /* 0068 */  0x2D, 0x20, 0x41, 0x33, 0x5F, 0x5E, 0x33, 0x4A,
            /* 0070 */  0x24, 0x3D, 0x2E, 0x28, 0x42, 0x55, 0x3C, 0x25,
            /* 0078 */  0x3F, 0x3F, 0x32, 0x5B, 0x40, 0x44, 0x26, 0x59,
            /* 0080 */  0x57, 0x23, 0x40, 0x31, 0x36, 0x4F, 0x51, 0x49,
            /* 0088 */  0x51, 0x5A, 0x2F, 0x28, 0x4A, 0x39, 0x59, 0x55,
            /* 0090 */  0x3E, 0x28, 0x35, 0x59, 0x21, 0x45, 0x5E, 0x56,
            /* 0098 */  0x5D, 0x5E, 0x5A, 0x4C, 0x2B, 0x45, 0x20, 0x2D,
            /* 00A0 */  0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67,
            /* 00A8 */  0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20,
            /* 00B0 */  0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43,
            /* 00B8 */  0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69,
            /* 00C0 */  0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52,
            /* 00C8 */  0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65,
            /* 00D0 */  0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31,
            /* 00D8 */  0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36,
            /* 00E0 */  0x39, 0x38, 0x35, 0x28, 0x52, 0x29             
        })
        Name (OPV2, Buffer (0xE6)
        {
            /* 0000 */  0xC5, 0xDE, 0xD4, 0xCF, 0x0D, 0x8E, 0x71, 0x08,
            /* 0008 */  0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00,
            /* 0010 */  0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35,
            /* 0018 */  0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75,
            /* 0020 */  0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44,
            /* 0028 */  0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69,
            /* 0030 */  0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74,
            /* 0038 */  0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61,
            /* 0040 */  0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65,
            /* 0048 */  0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66,
            /* 0050 */  0x6F, 0x72, 0x20, 0x37, 0x37, 0x34, 0x32, 0x39,
            /* 0058 */  0x30, 0x5F, 0x31, 0x32, 0x36, 0x63, 0x20, 0x20,
            /* 0060 */  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
            /* 0068 */  0x2D, 0x20, 0x42, 0x34, 0x50, 0x5F, 0x34, 0x4D,
            /* 0070 */  0x25, 0x3E, 0x51, 0x29, 0x43, 0x56, 0x3D, 0x26,
            /* 0078 */  0x3C, 0x20, 0x33, 0x5C, 0x41, 0x45, 0x27, 0x58,
            /* 0080 */  0x55, 0x20, 0x43, 0x32, 0x37, 0x40, 0x52, 0x4A,
            /* 0088 */  0x50, 0x5D, 0x2E, 0x29, 0x4B, 0x38, 0x5A, 0x56,
            /* 0090 */  0x3F, 0x2B, 0x34, 0x5A, 0x26, 0x46, 0x5F, 0x57,
            /* 0098 */  0x5C, 0x21, 0x5B, 0x4D, 0x2C, 0x42, 0x20, 0x2D,
            /* 00A0 */  0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67,
            /* 00A8 */  0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20,
            /* 00B0 */  0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43,
            /* 00B8 */  0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69,
            /* 00C0 */  0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52,
            /* 00C8 */  0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65,
            /* 00D0 */  0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31,
            /* 00D8 */  0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36,
            /* 00E0 */  0x39, 0x38, 0x35, 0x28, 0x52, 0x29             
        })
        Method (HDSM, 4, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            CreateByteField (Arg0, 0x03, GUID)
            If (LEqual (Arg0, ToUUID ("a486d8f8-0bda-471b-a72b-6042a6b5bee0")))
            {
                If (LNotEqual (Arg1, 0x0100))
                {
                    Return (0x80000002)
                }

                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Return (Buffer (0x04)
                        {
                             0x01, 0x00, 0x01, 0x0C                         
                        })
                    }
                    ElseIf (LEqual (_T_0, 0x10))
                    {
                        CreateWordField (Arg3, 0x02, USRG)
                        If (LEqual (USRG, 0x564B))
                        {
                            If (LEqual (\_SB.PCI0.GFX0.IGID, 0x0116))
                            {
                                Return (OPV1)
                            }
                            ElseIf (LEqual (\_SB.PCI0.GFX0.IGID, 0x0126))
                            {
                                Return (OPV2)
                            }
                        }

                        Return (Zero)
                    }
                    ElseIf (LEqual (_T_0, 0x11))
                    {
                        Return (Zero)
                    }
                    ElseIf (LEqual (_T_0, 0x1A))
                    {
                        CreateField (Arg3, 0x18, 0x02, OMPR)
                        CreateField (Arg3, Zero, One, FLCH)
                        If (ToInteger (FLCH))
                        {
                            Store (OMPR, OPCE)
                        }

                        Store (Buffer (0x04)
                            {
                                 0x00, 0x00, 0x00, 0x00                         
                            }, Local0)
                        CreateField (Local0, Zero, One, OPEN)
                        CreateField (Local0, 0x03, 0x02, CGCS)
                        CreateField (Local0, 0x06, One, SHPC)
                        CreateField (Local0, 0x18, 0x03, DGPC)
                        CreateField (Local0, 0x1B, 0x02, HDAC)
                        Store (One, OPEN)
                        Store (One, SHPC)
                        Store (0x02, HDAC)
                        Store (One, DGPC)
                        If (LNotEqual (\_SB.PCI0.PEG0.PEGP.SGST (), Zero))
                        {
                            Store (0x03, CGCS)
                        }

                        Return (Local0)
                    }
                    ElseIf (LEqual (_T_0, 0x1B))
                    {
                        Store (Arg3, Local0)
                        CreateField (Local0, Zero, One, OPFL)
                        CreateField (Local0, One, One, OPVL)
                        If (ToInteger (OPVL))
                        {
                            Store (Zero, OPTF)
                            If (ToInteger (OPFL))
                            {
                                Store (One, OPTF)
                            }
                        }

                        Store (OPTF, Local0)
                        Return (Local0)
                    }

                    Break
                }

                Return (0x80000002)
            }

            If (LEqual (Arg0, ToUUID ("95db88fd-940a-4253-a446-70ce0504aedf")))
            {
                Return (\_SB.PCI0.PEG0.PEGP.SPB (Arg0, Arg1, Arg2, Arg3))
            }
        }

        Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
        {
            CreateByteField (Arg0, 0x03, GUID)
            Return (\_SB.PCI0.GFX0.HDSM (Arg0, Arg1, Arg2, Arg3))
        }

        OperationRegion (BPCI, SystemMemory, EBAS, 0x1000)
        Field (BPCI, ByteAcc, NoLock, Preserve)
        {
            Offset (0x04), 
            PCIC,   32, 
            Offset (0x10), 
            GMM1,   32, 
            GMM2,   32, 
            Offset (0x1C), 
            GMM3,   32, 
            Offset (0x24), 
            GIO1,   32, 
            Offset (0x3C), 
            GIRQ,   32, 
            SID,    32, 
            Offset (0x488), 
                ,   25, 
            NHDM,   1
        }

        OperationRegion (BPC1, SystemMemory, EBAS, 0x2000)
        Field (BPC1, ByteAcc, NoLock, Preserve)
        {
            Offset (0x1040), 
            SIDN,   32
        }

        Name (BUFF, Buffer (0x20) {})
        CreateDWordField (BUFF, Zero, BUF1)
        CreateDWordField (BUFF, One, BUF2)
        CreateDWordField (BUFF, 0x02, BUF3)
        CreateDWordField (BUFF, 0x03, BUF4)
        CreateDWordField (BUFF, 0x04, BUF5)
        CreateDWordField (BUFF, 0x05, BUF6)
        CreateDWordField (BUFF, 0x06, BUF7)
        CreateDWordField (BUFF, 0x07, BUF8)
        Method (_ON, 0, Serialized)  // _ON_: Power On
        {
            SGON ()
            Store (BUF1, PCIC)
            Store (BUF2, GMM1)
            Store (BUF3, GMM2)
            Store (BUF4, GMM3)
            Store (BUF5, GIO1)
            Store (BUF6, GIRQ)
            Store (BUF7, SID)
            Store (BUF7, SIDN)
            Sleep (0x64)
            If (OPTF)
            {
                Store (One, NHDM)
            }
        }

        Method (_OFF, 0, Serialized)  // _OFF: Power Off
        {
            Store (PCIC, BUF1)
            Store (GMM1, BUF2)
            Store (GMM2, BUF3)
            Store (GMM3, BUF4)
            Store (GIO1, BUF5)
            Store (GIRQ, BUF6)
            Store (SID, BUF7)
            SGOF ()
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        OperationRegion (XGPU, PCI_Config, Zero, 0x30)
        Field (XGPU, AnyAcc, NoLock, Preserve)
        {
            Offset (0x02), 
            IGID,   16
        }

        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            Store (DID1, Index (TLPK, Zero))
            Store (DID2, Index (TLPK, 0x02))
            Store (DID3, Index (TLPK, 0x04))
            Store (DID4, Index (TLPK, 0x06))
            Store (DID5, Index (TLPK, 0x08))
            Store (DID6, Index (TLPK, 0x0A))
            Store (DID7, Index (TLPK, 0x0C))
            Store (DID2, Index (TLPK, 0x0E))
            Store (DID1, Index (TLPK, 0x0F))
            Store (DID2, Index (TLPK, 0x11))
            Store (DID3, Index (TLPK, 0x12))
            Store (DID2, Index (TLPK, 0x14))
            Store (DID4, Index (TLPK, 0x15))
            Store (DID2, Index (TLPK, 0x17))
            Store (DID5, Index (TLPK, 0x18))
            Store (DID2, Index (TLPK, 0x1A))
            Store (DID6, Index (TLPK, 0x1B))
            Store (DID2, Index (TLPK, 0x1D))
            Store (DID7, Index (TLPK, 0x1E))
            Store (One, CLID)
        }

        OperationRegion (NVIG, SystemMemory, NVGA, 0x0400)
        Field (NVIG, AnyAcc, NoLock, Preserve)
        {
            NISG,   128, 
            NISZ,   32, 
            NIVR,   32, 
            GPSS,   32, 
            GACD,   16, 
            GATD,   16, 
            LDES,   8, 
            DKST,   8, 
            DACE,   8, 
            DHPE,   8, 
            DHPS,   8, 
            SGNC,   8, 
            GPPO,   8, 
            USPM,   8, 
            GPSP,   8, 
            TLSN,   8, 
            DOSF,   8, 
            ELCT,   16
        }

        Name (TLPK, Package (0x20)
        {
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C
        })
        Method (INDL, 0, Serialized)
        {
            Store (Zero, NXD1)
            Store (Zero, NXD2)
            Store (Zero, NXD3)
            Store (Zero, NXD4)
            Store (Zero, NXD5)
            Store (Zero, NXD6)
            Store (Zero, NXD7)
            Store (Zero, NXD8)
        }

        Method (SND1, 1, Serialized)
        {
            If (LEqual (Arg0, DID1))
            {
                Store (One, NXD1)
            }

            If (LEqual (Arg0, DID2))
            {
                Store (One, NXD2)
            }

            If (LEqual (Arg0, DID3))
            {
                Store (One, NXD3)
            }

            If (LEqual (Arg0, DID4))
            {
                Store (One, NXD4)
            }

            If (LEqual (Arg0, DID5))
            {
                Store (One, NXD5)
            }

            If (LEqual (Arg0, DID6))
            {
                Store (One, NXD6)
            }

            If (LEqual (Arg0, DID7))
            {
                Store (One, NXD7)
            }

            If (LEqual (Arg0, DID8))
            {
                Store (One, NXD8)
            }
        }

        Method (SNXD, 1, Serialized)
        {
            INDL ()
            Store (One, Local0)
            Store (Zero, Local1)
            While (LLess (Local0, Arg0))
            {
                If (LEqual (DerefOf (Index (TLPK, Local1)), 0x2C))
                {
                    Increment (Local0)
                }

                Increment (Local1)
            }

            SND1 (DerefOf (Index (TLPK, Local1)))
            Increment (Local1)
            If (LNotEqual (DerefOf (Index (TLPK, Local1)), 0x2C))
            {
                SND1 (DerefOf (Index (TLPK, Local1)))
            }
        }

        Method (CTOI, 1, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            While (One)
            {
                Store (ToInteger (Arg0), _T_0)
                If (LEqual (_T_0, One))
                {
                    Return (One)
                }
                ElseIf (LEqual (_T_0, 0x02))
                {
                    Return (0x02)
                }
                ElseIf (LEqual (_T_0, 0x04))
                {
                    Return (0x03)
                }
                ElseIf (LEqual (_T_0, 0x08))
                {
                    Return (0x04)
                }
                ElseIf (LEqual (_T_0, 0x10))
                {
                    Return (0x05)
                }
                ElseIf (LEqual (_T_0, 0x20))
                {
                    Return (0x06)
                }
                ElseIf (LEqual (_T_0, 0x40))
                {
                    Return (0x07)
                }
                ElseIf (LEqual (_T_0, 0x03))
                {
                    Return (0x08)
                }
                ElseIf (LEqual (_T_0, 0x06))
                {
                    Return (0x09)
                }
                ElseIf (LEqual (_T_0, 0x0A))
                {
                    Return (0x0A)
                }
                ElseIf (LEqual (_T_0, 0x12))
                {
                    Return (0x0B)
                }
                ElseIf (LEqual (_T_0, 0x22))
                {
                    Return (0x0C)
                }
                ElseIf (LEqual (_T_0, 0x42))
                {
                    Return (0x0D)
                }
                Else
                {
                    Return (One)
                }

                Break
            }
        }

        Method (HDSM, 4, Serialized)
        {
            Return (\_SB.PCI0.PEG0.PEGP.HDSM (Arg0, Arg1, Arg2, Arg3))
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (VSTS, One)
        Name (TBUD, 0xEA60)
        Name (CTBD, 0xEA60)
        Name (TTBD, 0xEA60)
        Name (PSCP, Zero)
        Name (LE11, Zero)
        Method (THCH, 2, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            While (One)
            {
                Store (ToInteger (Arg0), _T_0)
                If (LEqual (_T_0, 0x02))
                {
                    And (Arg1, 0x000FFFFF, TBUD)
                    ShiftRight (Arg1, 0x1E, Local0)
                    And (Local0, One, VSTS)
                    Notify (\_SB.PCI0.PEG0.PEGP, 0xC0)
                }

                Break
            }
        }

        Method (SPB, 4, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            P8XH (Zero, 0xF3)
            Store ("------- SPB DSM --------", Debug)
            If (Zero)
            {
                Return (0x80000002)
            }

            Store (One, LE11)
            If (LNotEqual (Arg1, 0x0101))
            {
                Return (0x80000002)
            }

            While (One)
            {
                Store (ToInteger (Arg2), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Name (FMSK, Buffer (0x08)
                    {
                         0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF 
                    })
                    Store (Buffer (0x08)
                        {
                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
                        }, Local0)
                    Divide (Zero, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x20, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x21, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x22, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x23, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x24, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Divide (0x2A, 0x08, Local2, Local1)
                    ShiftLeft (One, Local2, Local2)
                    Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    Store (SizeOf (Local0), Local1)
                    While (LNotEqual (Local1, Zero))
                    {
                        Decrement (Local1)
                        Store (DerefOf (Index (FMSK, Local1)), Local2)
                        And (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1))
                    }

                    Return (Local0)
                }
                ElseIf (LEqual (_T_0, 0x20))
                {
                    Store (TBUD, Local1)
                    And (Local1, 0x000FFFFF, Local1)
                    If (LNotEqual (VSTS, Zero))
                    {
                        Or (Local1, 0x40000000, Local1)
                    }

                    Return (Local1)
                }
                ElseIf (LEqual (_T_0, 0x21))
                {
                    Return (\_PR.CPU0._PSS)
                }
                ElseIf (LEqual (_T_0, 0x22))
                {
                    CreateByteField (Arg3, Zero, PCAP)
                    Store (PCAP, PSCP)
                    If (LNotEqual (PCAP, \_PR.CPU0._PPC))
                    {
                        If (LEqual (PCAP, Zero))
                        {
                            NVSM (Zero)
                        }
                        Else
                        {
                            NVSM (One)
                        }
                    }

                    If (LEqual (FPPC, Zero))
                    {
                        Store (PCAP, \_PR.CPU0._PPC)
                        Notify (\_PR.CPU0, 0x80)
                        If (And (PDC1, 0x08))
                        {
                            Notify (\_PR.CPU1, 0x80)
                        }

                        If (And (PDC2, 0x08))
                        {
                            Notify (\_PR.CPU2, 0x80)
                        }

                        If (And (PDC3, 0x08))
                        {
                            Notify (\_PR.CPU3, 0x80)
                        }

                        If (And (PDC4, 0x08))
                        {
                            Notify (\_PR.CPU4, 0x80)
                        }

                        If (And (PDC5, 0x08))
                        {
                            Notify (\_PR.CPU5, 0x80)
                        }

                        If (And (PDC6, 0x08))
                        {
                            Notify (\_PR.CPU6, 0x80)
                        }

                        If (And (PDC7, 0x08))
                        {
                            Notify (\_PR.CPU7, 0x80)
                        }
                    }
                    Else
                    {
                    }

                    Return (PCAP)
                }
                ElseIf (LEqual (_T_0, 0x23))
                {
                    Return (PSCP)
                }
                ElseIf (LEqual (_T_0, 0x24))
                {
                    CreateField (Arg3, Zero, 0x14, THBG)
                    CreateField (Arg3, 0x1E, One, DDVE)
                    Store (THBG, CTBD)
                }
                ElseIf (LEqual (_T_0, 0x2A))
                {
                    Return (SSNR (Arg3))
                }

                Break
            }

            Return (0x80000002)
        }

        Name (SBHS, Buffer (0x08) {})
        CreateDWordField (SBHS, Zero, VERV)
        CreateDWordField (SBHS, 0x04, NUMS)
        Name (SSCP, Buffer (0x2C) {})
        CreateDWordField (SSCP, 0x04, CSNT)
        CreateDWordField (SSCP, 0x08, CPTI)
        CreateDWordField (SSCP, 0x0C, CICA)
        CreateDWordField (SSCP, 0x10, CIRC)
        CreateDWordField (SSCP, 0x14, CICV)
        CreateDWordField (SSCP, 0x18, CIRA)
        CreateDWordField (SSCP, 0x1C, CIAV)
        CreateDWordField (SSCP, 0x20, CIEP)
        CreateDWordField (SSCP, 0x24, CPPF)
        CreateDWordField (SSCP, 0x28, CSNR)
        Name (SSGP, Buffer (0x2C) {})
        CreateDWordField (SSGP, 0x04, GSNT)
        CreateDWordField (SSGP, 0x08, GPTI)
        CreateDWordField (SSGP, 0x0C, GICA)
        CreateDWordField (SSGP, 0x10, GIRC)
        CreateDWordField (SSGP, 0x14, GICV)
        CreateDWordField (SSGP, 0x18, GIRA)
        CreateDWordField (SSGP, 0x1C, GIAV)
        CreateDWordField (SSGP, 0x20, GIEP)
        CreateDWordField (SSGP, 0x24, GPPF)
        CreateDWordField (SSGP, 0x28, GSNR)
        Name (SCPP, Buffer (0x48) {})
        CreateDWordField (SCPP, Zero, VRV1)
        CreateDWordField (SCPP, 0x04, VCAP)
        CreateDWordField (SCPP, 0x08, VCCP)
        CreateDWordField (SCPP, 0x0C, VCDP)
        CreateDWordField (SCPP, 0x10, VCEP)
        CreateDWordField (SCPP, 0x14, VCGP)
        CreateDWordField (SCPP, 0x18, VCHP)
        CreateDWordField (SCPP, 0x1C, VCXP)
        CreateDWordField (SCPP, 0x20, VCYP)
        CreateDWordField (SCPP, 0x24, VCZP)
        CreateDWordField (SCPP, 0x28, VCKP)
        CreateDWordField (SCPP, 0x2C, VCMP)
        CreateDWordField (SCPP, 0x30, VCNP)
        CreateDWordField (SCPP, 0x34, VCAL)
        CreateDWordField (SCPP, 0x38, VCBE)
        CreateDWordField (SCPP, 0x3C, VCGA)
        CreateDWordField (SCPP, 0x40, VCPP)
        CreateDWordField (SCPP, 0x44, VCDE)
        Name (SGPP, Buffer (0x28) {})
        CreateDWordField (SGPP, Zero, VRV2)
        CreateDWordField (SGPP, 0x04, VGWP)
        CreateDWordField (SGPP, 0x08, VGPP)
        CreateDWordField (SGPP, 0x0C, VGQP)
        CreateDWordField (SGPP, 0x10, VGRP)
        CreateDWordField (SGPP, 0x14, VGAP)
        CreateDWordField (SGPP, 0x18, VGBP)
        CreateDWordField (SGPP, 0x1C, VGCP)
        CreateDWordField (SGPP, 0x20, VGDP)
        CreateDWordField (SGPP, 0x24, VGDE)
        Method (SSNR, 1, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            While (One)
            {
                Store (ToInteger (Arg0), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Store (0x00010000, VERV)
                    Store (0x02, NUMS)
                    Return (SBHS)
                }
                ElseIf (LEqual (_T_0, One))
                {
                    Store (0x00010000, VRV1)
                    Store (0x03E8, VCAP)
                    Store (0x0258, VCCP)
                    Store (0x0A, VCDP)
                    Store (0x0A, VCEP)
                    Store (0x07D0, VCGP)
                    Store (0x02BC, VCHP)
                    Store (0x02AE, VCXP)
                    Store (0x9C, VCYP)
                    Store (0x9C, VCZP)
                    Store (One, VCKP)
                    Store (Zero, VCMP)
                    Store (Zero, VCNP)
                    Store (0x03D2, VCAL)
                    Store (0x05A1, VCBE)
                    Store (0x11, VCGA)
                    Store (0x64, VCPP)
                    Store (One, VCDE)
                    Return (SCPP)
                }
                ElseIf (LEqual (_T_0, 0x02))
                {
                    Store (0x00010000, VRV2)
                    Store (0x02EE, VGWP)
                    Store (0x02EE, VGPP)
                    Store (0x0A, VGQP)
                    Store (0x0A, VGRP)
                    Store (One, VGAP)
                    Store (0x01F4, VGBP)
                    Store (Zero, VGCP)
                    Store (Zero, VGDP)
                    Store (One, VGDE)
                    Return (SGPP)
                }
                ElseIf (LEqual (_T_0, 0x03))
                {
                    Store (Zero, Index (SSCP, Zero))
                    Store (Zero, CSNT)
                    Store (One, CPTI)
                    Store (0x8A, CICA)
                    Store (Zero, CIRC)
                    Store (0x27FF, CICV)
                    Store (0x05, CIRA)
                    Store (0xA000, CIAV)
                    Store (0x03, CIEP)
                    Store (0x0F, CPPF)
                    Store (0x04, CSNR)
                    Store (One, Index (SSGP, Zero))
                    Store (Zero, GSNT)
                    Store (One, GPTI)
                    Store (0x80, GICA)
                    Store (Zero, GIRC)
                    Store (0x27FF, GICV)
                    Store (0x05, GIRA)
                    Store (0xA000, GIAV)
                    Store (0x03, GIEP)
                    Store (0x0F, GPPF)
                    Store (0x04, GSNR)
                    Return (Concatenate (SSCP, SSGP))
                }

                Break
            }

            Return (0x80000002)
        }

        Method (VPTS, 0, NotSerialized)
        {
            If (One)
            {
                Store (Zero, LE11)
            }
        }

        Method (VWAK, 0, NotSerialized)
        {
            If (One)
            {
                Store (One, LE11)
            }
        }
    }

    Scope (\_SB.PCI0)
    {
        Device (WMI1)
        {
            Name (_HID, "pnp0c14")  // _HID: Hardware ID
            Name (_UID, "OPT1")  // _UID: Unique ID
            Name (_WDG, Buffer (0x14)
            {
                /* 0000 */  0x3C, 0x5C, 0xCB, 0xF6, 0xAE, 0x9C, 0xBD, 0x4E,
                /* 0008 */  0xB5, 0x77, 0x93, 0x1E, 0xA3, 0x2A, 0x2C, 0xC0,
                /* 0010 */  0x4D, 0x58, 0x01, 0x02                         
            })
            Method (WMMX, 3, NotSerialized)
            {
                CreateDWordField (Arg2, Zero, FUNC)
                If (LEqual (FUNC, 0x534F525F))
                {
                    If (LGreaterEqual (SizeOf (Arg2), 0x08))
                    {
                        CreateDWordField (Arg2, 0x04, ARGS)
                        CreateDWordField (Arg2, 0x08, XARG)
                        Return (\_SB.PCI0.PEG0.PEGP._ROM (ARGS, XARG))
                    }
                }

                If (LEqual (FUNC, 0x4D53445F))
                {
                    If (LGreaterEqual (SizeOf (Arg2), 0x1C))
                    {
                        CreateField (Arg2, Zero, 0x80, MUID)
                        CreateDWordField (Arg2, 0x10, REVI)
                        CreateDWordField (Arg2, 0x14, SFNC)
                        CreateField (Arg2, 0xE0, 0x20, XRG0)
                        If (CondRefOf (\_SB.PCI0.GFX0._DSM))
                        {
                            Return (\_SB.PCI0.GFX0._DSM (MUID, REVI, SFNC, XRG0))
                        }
                    }
                }

                Return (Zero)
            }
        }
    }
}

